CREATE OR REPLACE
PROCEDURE SCO_IMPORT.IMPORT_SCOLARIX IS

--
-- Procédure de migration de SCOLARITE vers SCO_IMPORT du 21/02/2013 à exécuter depuis le user GRHUM
--
-- Rem : fichier encodé UTF-8

--
--
-- Fichier : 4/5
-- Type : PLSQL
-- Schema : SCO_IMPORT
-- Numero de version : 
-- Date de publication : 21/02/2013
-- Auteur(s) : Association Cocktail
--
--

BEGIN

	-- Introduction
	DBMS_OUTPUT.PUT_LINE('Démarrage de l''importation des données...');

	-- Vidage des tables d'import
	EXECUTE IMMEDIATE('TRUNCATE TABLE SCO_IMPORT.Z_ID');  
  	EXECUTE IMMEDIATE('TRUNCATE TABLE SCO_IMPORT.IMPORT_AP');  
	EXECUTE IMMEDIATE('TRUNCATE TABLE SCO_IMPORT.IMPORT_LIEN');  
	EXECUTE IMMEDIATE('TRUNCATE TABLE SCO_IMPORT.IMPORT_EC');  
	EXECUTE IMMEDIATE('TRUNCATE TABLE SCO_IMPORT.IMPORT_UE');  
	EXECUTE IMMEDIATE('TRUNCATE TABLE SCO_IMPORT.IMPORT_PARCOURS');  
	EXECUTE IMMEDIATE('TRUNCATE TABLE SCO_IMPORT.IMPORT_DIPLOME');  
	EXECUTE IMMEDIATE('TRUNCATE TABLE SCO_IMPORT.IMPORT_DISCIPLINE');  
	EXECUTE IMMEDIATE('TRUNCATE TABLE SCO_IMPORT.IMPORT_DOMAINE');  
	EXECUTE IMMEDIATE('TRUNCATE TABLE SCO_IMPORT.IMPORT_GRADE');   
	EXECUTE IMMEDIATE('TRUNCATE TABLE SCO_IMPORT.IMPORT_SPECIALISATION');   
	EXECUTE IMMEDIATE('TRUNCATE TABLE SCO_IMPORT.IMPORT_SPECIALITE');  
	EXECUTE IMMEDIATE('TRUNCATE TABLE SCO_IMPORT.IMPORT_VOCATION'); 
	EXECUTE IMMEDIATE('TRUNCATE TABLE SCO_IMPORT.IMPORT_MODE_AP');
	EXECUTE IMMEDIATE('TRUNCATE TABLE SCO_IMPORT.IMPORT_TYPE_AP');
	EXECUTE IMMEDIATE('TRUNCATE TABLE SCO_IMPORT.IMPORT_STATUT_FORMATION');  
	EXECUTE IMMEDIATE('TRUNCATE TABLE SCO_IMPORT.IMPORT_TYPE_ORGANISATION'); 
	DBMS_OUTPUT.PUT_LINE('Tables de SCO_IMPORT vidées : OK');

  	COMMIT;

  	-- Alimentation des tables temporaires
  	INSERT INTO SCO_IMPORT.Z_ID (ID_SOUR, ID_DEST, ID_TYPE)
 	SELECT MAP_KEY, IMPORT_AP_SEQ.nextval, 'AP' FROM SCOLARITE.SCOL_MAQUETTE_AP;
  	INSERT INTO SCO_IMPORT.Z_ID (ID_SOUR, ID_DEST, ID_TYPE)
  	SELECT MEC_KEY, IMPORT_EC_SEQ.nextval, 'EC' FROM SCOLARITE.SCOL_MAQUETTE_EC;
  	INSERT INTO SCO_IMPORT.Z_ID (ID_SOUR, ID_DEST, ID_TYPE)
  	SELECT MUE_KEY, IMPORT_UE_SEQ.nextval, 'UE' FROM SCOLARITE.SCOL_MAQUETTE_UE;
  	DBMS_OUTPUT.PUT_LINE('Alimentation des tables temporaires : OK');

	-- Insertion des données dans IMPORT_DISCIPLINE
	INSERT INTO SCO_IMPORT.IMPORT_DISCIPLINE
	(ID_DISCIPLINE, KEY, CODE, LIBELLE_COURT, LIBELLE, VALIDE)
	SELECT IMPORT_DISCIPLINE_SEQ.nextval, FDSC_KEY, FDSC_CODE, FDSC_ABREVIATION, FDSC_LIBELLE, DECODE(FDSC_VALIDITE, 'O', '1','N','0')
  	FROM SCOLARITE.SCOL_FORMATION_DISCIPLINE;
	DBMS_OUTPUT.PUT_LINE('Alimentation de la table Disciplines : OK');

	-- Insertion des données dans IMPORT_DOMAINE
	INSERT INTO SCO_IMPORT.IMPORT_DOMAINE
	(ID_DOMAINE, CODE, LIBELLE_COURT, LIBELLE, TYPE, VALIDE)
	SELECT IMPORT_DOMAINE_SEQ.nextval, FDOM_CODE, FDOM_ABREVIATION, FDOM_LIBELLE, FDOM_TYPE, DECODE(FDOM_VALIDITE, 'O', '1','N','0')
	FROM SCOLARITE.SCOL_FORMATION_DOMAINE;
	DBMS_OUTPUT.PUT_LINE('Alimentation de la table Domaines : OK');

	-- Insertion des données dans IMPORT_GRADE
  	INSERT INTO SCO_IMPORT.IMPORT_GRADE
	(ID_GRADE, CODE, LIBELLE_COURT, LIBELLE, TYPE)
	SELECT IMPORT_GRADE_SEQ.nextval, FGRA_CODE, FGRA_ABREVIATION, FGRA_LIBELLE, FGRA_CODAGE
	FROM SCOLARITE.SCOL_FORMATION_GRADE;
	DBMS_OUTPUT.PUT_LINE('Alimentation de la table Grades : OK');

  	-- Insertion des données dans IMPORT_SPECIALISATION
	INSERT INTO SCO_IMPORT.IMPORT_SPECIALISATION
	(ID_SPECIALISATION, KEY, CODE, LIBELLE_COURT, LIBELLE)
	SELECT IMPORT_SPECIALISATION_SEQ.nextval, FSPN_KEY, FDIP_CODE, FSPN_ABREVIATION, FSPN_LIBELLE
	FROM SCOLARITE.SCOL_FORMATION_SPECIALISATION;
	DBMS_OUTPUT.PUT_LINE('Alimentation de la table Specialisations : OK');

	-- Insertion des données dans IMPORT_SPECIALITE
	INSERT INTO SCO_IMPORT.IMPORT_SPECIALITE
	(ID_SPECIALITE, CODE, LIBELLE_COURT, LIBELLE, VALIDE)
	SELECT IMPORT_SPECIALITE_SEQ.nextval, FSPE_CODE, FSPE_ABREVIATION, FSPE_LIBELLE, DECODE(FSPE_VALIDITE, 'O', '1','N','0')
	FROM SCOLARITE.SCOL_FORMATION_SPECIALITE;
	DBMS_OUTPUT.PUT_LINE('Alimentation de la table Specialités : OK');

	-- Insertion des données dans IMPORT_VOCATION
	INSERT INTO SCO_IMPORT.IMPORT_VOCATION
	(ID_VOCATION, CODE, LIBELLE_COURT, LIBELLE, VALIDE)
	SELECT IMPORT_VOCATION_SEQ.nextval, FVOC_CODE, FVOC_ABREVIATION, FVOC_LIBELLE, DECODE(FVOC_VALIDITE, 'O', '1','N','0')
	FROM SCOLARITE.SCOL_FORMATION_VOCATION;
	DBMS_OUTPUT.PUT_LINE('Alimentation de la table Vocations : OK');

  	-- Insertion des données dans IMPORT_MODE_AP
	INSERT INTO SCO_IMPORT.IMPORT_MODE_AP
	(ID_MODE_AP, CODE, LIBELLE_COURT, LIBELLE)
	SELECT IMPORT_MODE_AP_SEQ.nextval, MHMO_CODE, MHMO_ABREVIATION, MHMO_LIBELLE
  	FROM SCOLARITE.SCOL_MAQUETTE_HORAIRE_MODE;
	DBMS_OUTPUT.PUT_LINE('Alimentation de la table Modes d''AP : OK');
  
  	-- Insertion des données dans IMPORT_TYPE_AP
	INSERT INTO SCO_IMPORT.IMPORT_TYPE_AP
	(ID_TYPE_AP, CODE, LIBELLE_COURT, LIBELLE)
	SELECT IMPORT_TYPE_AP_SEQ.nextval, MHCO_CODE, MHCO_ABREVIATION, MHCO_LIBELLE
  	FROM SCOLARITE.SCOL_MAQUETTE_HORAIRE_CODE;
	DBMS_OUTPUT.PUT_LINE('Alimentation de la table Types d''AP : OK');
  
	-- Insertion des données dans IMPORT_STATUT_FORMATION
  	INSERT INTO SCO_IMPORT.IMPORT_STATUT_FORMATION (ID_STATUT_FORMATION, CODE, LIBELLE) VALUES (IMPORT_STATUT_FORMATION_SEQ.nextval, 'H', 'Habilité');
  	INSERT INTO SCO_IMPORT.IMPORT_STATUT_FORMATION (ID_STATUT_FORMATION, CODE, LIBELLE) VALUES (IMPORT_STATUT_FORMATION_SEQ.nextval, 'F', 'Fictif');
  	INSERT INTO SCO_IMPORT.IMPORT_STATUT_FORMATION (ID_STATUT_FORMATION, CODE, LIBELLE) VALUES (IMPORT_STATUT_FORMATION_SEQ.nextval, 'C', 'En construction');
	DBMS_OUTPUT.PUT_LINE('Alimentation de la table Statuts de formation : OK');
  
	-- Insertion des données dans IMPORT_TYPE_ORGANISATION
  	INSERT INTO SCO_IMPORT.IMPORT_TYPE_ORGANISATION (ID_TYPE_ORGANISATION, CODE, KEY, LIBELLE) VALUES (IMPORT_TYPE_ORGANISATION_SEQ.nextval, 'S', 'O', 'Semestriel');
  	INSERT INTO SCO_IMPORT.IMPORT_TYPE_ORGANISATION (ID_TYPE_ORGANISATION, CODE, KEY, LIBELLE) VALUES (IMPORT_TYPE_ORGANISATION_SEQ.nextval, 'A', 'N', 'Annuel');
	DBMS_OUTPUT.PUT_LINE('Alimentation de la table Types d''organisation : OK');
  
	-- Insertion des données dans IMPORT_AP
  	INSERT INTO SCO_IMPORT.IMPORT_AP
	(ID_AP, VERSION_DIPLOME_ID, CODE, LIBELLE, TYPE_AP_ID, MODE_AP_ID, VALEUR_HEURES, NB_GROUPES, SEUIL)
	SELECT ID_DEST, SCOL_MAQUETTE_AP.FANN_KEY, MAP_KEY, MAP_LIBELLE, SCO_IMPORT.IMPORT_TYPE_AP.ID_TYPE_AP, SCO_IMPORT.IMPORT_MODE_AP.ID_MODE_AP, MAP_VALEUR, MAP_GROUPE_PREVU, MAP_SEUIL 
  	FROM SCOLARITE.SCOL_MAQUETTE_AP, SCOLARITE.SCOL_FORMATION_ANNEE, SCO_IMPORT.IMPORT_TYPE_AP, SCO_IMPORT.IMPORT_MODE_AP, SCO_IMPORT.Z_ID
  	WHERE SCOLARITE.SCOL_MAQUETTE_AP.MAP_KEY = SCO_IMPORT.Z_ID.ID_SOUR
  	AND SCO_IMPORT.Z_ID.ID_TYPE = 'AP'
  	AND SCOLARITE.SCOL_MAQUETTE_AP.MHCO_CODE = SCO_IMPORT.IMPORT_TYPE_AP.CODE
  	AND SCOLARITE.SCOL_MAQUETTE_AP.MHMO_CODE = SCO_IMPORT.IMPORT_MODE_AP.CODE
  	AND SCOLARITE.SCOL_FORMATION_ANNEE.FANN_KEY = SCOLARITE.SCOL_MAQUETTE_AP.FANN_KEY
  	AND SCOLARITE.SCOL_FORMATION_ANNEE.FANN_KEY = '2013';
	DBMS_OUTPUT.PUT_LINE('Alimentation de la table AP : OK');

	-- Insertion des données dans IMPORT_EC
	INSERT INTO SCO_IMPORT.IMPORT_EC
	(ID_EC, DISCIPLINE_ID, VERSION_DIPLOME_ID, CODE, LIBELLE_COURT, LIBELLE, CREDIT_ECTS, TRAVAIL_ETUDIANT, BASE_NOTE)
	SELECT ID_DEST, IMPORT_DISCIPLINE.ID_DISCIPLINE, SCOL_MAQUETTE_EC.FANN_KEY, MEC_CODE, MEC_LIBELLE_COURT, MEC_LIBELLE, MEC_POINTS, MEC_HORAIRE_ETU, MEC_BASE
	FROM SCOLARITE.SCOL_MAQUETTE_EC, SCOLARITE.SCOL_FORMATION_ANNEE, SCO_IMPORT.IMPORT_DISCIPLINE, SCO_IMPORT.Z_ID
	WHERE SCOLARITE.SCOL_MAQUETTE_EC.MEC_KEY = SCO_IMPORT.Z_ID.ID_SOUR
  	AND SCO_IMPORT.Z_ID.ID_TYPE = 'EC'
  	AND SCOLARITE.SCOL_MAQUETTE_EC.FDSC_KEY = SCO_IMPORT.IMPORT_DISCIPLINE.KEY
  	AND SCOLARITE.SCOL_FORMATION_ANNEE.FANN_KEY = SCOLARITE.SCOL_MAQUETTE_EC.FANN_KEY
	AND SCOLARITE.SCOL_FORMATION_ANNEE.FANN_KEY = '2013';
	DBMS_OUTPUT.PUT_LINE('Alimentation de la table EC : OK');

	-- Insertion des données dans IMPORT_REPARITION_AP
  	INSERT INTO SCO_IMPORT.IMPORT_LIEN
	(ID_LIEN, EC_ID, AP_ID, SEMESTRE, MAJEUR)
	SELECT IMPORT_LIEN_SEQ.nextval, ALIAS_EC.ID_DEST, ALIAS_AP.ID_DEST, MRAP_SEMESTRE, MRAP_MAJEUR
	FROM SCOLARITE.SCOL_MAQUETTE_REPARTITION_AP, SCOLARITE.SCOL_FORMATION_ANNEE, SCO_IMPORT.Z_ID ALIAS_AP, SCO_IMPORT.Z_ID ALIAS_EC
	WHERE SCOLARITE.SCOL_MAQUETTE_REPARTITION_AP.MAP_KEY = ALIAS_AP.ID_SOUR
  	AND ALIAS_AP.ID_TYPE = 'AP'
  	AND SCOLARITE.SCOL_MAQUETTE_REPARTITION_AP.MEC_KEY = ALIAS_EC.ID_SOUR
  	AND ALIAS_EC.ID_TYPE = 'EC'
  	AND SCOLARITE.SCOL_FORMATION_ANNEE.FANN_KEY = SCOLARITE.SCOL_MAQUETTE_REPARTITION_AP.FANN_KEY
	AND SCOLARITE.SCOL_FORMATION_ANNEE.FANN_KEY = '2013';
	DBMS_OUTPUT.PUT_LINE('Alimentation de la table Répartitions d AP : OK');

	-- Insertion des données dans IMPORT_UE
	INSERT INTO SCO_IMPORT.IMPORT_UE
	(ID_UE, DOMAINE_ID, VERSION_DIPLOME_ID, CODE, LIBELLE, CREDIT_ECTS, TRAVAIL_ETUDIANT)
	SELECT ID_DEST, IMPORT_DOMAINE.ID_DOMAINE, SCOL_MAQUETTE_UE.FANN_KEY, MUE_CODE, MUE_LIBELLE, MUE_POINTS, MUE_HORAIRE_ETU 
	FROM SCOLARITE.SCOL_MAQUETTE_UE, SCOLARITE.SCOL_FORMATION_ANNEE, SCO_IMPORT.IMPORT_DOMAINE, SCO_IMPORT.Z_ID
	WHERE SCOLARITE.SCOL_MAQUETTE_UE.MUE_KEY = SCO_IMPORT.Z_ID.ID_SOUR
  	AND SCO_IMPORT.Z_ID.ID_TYPE = 'UE'
  	AND SCOLARITE.SCOL_MAQUETTE_UE.FDOM_CODE = SCO_IMPORT.IMPORT_DOMAINE.CODE
  	AND SCOLARITE.SCOL_FORMATION_ANNEE.FANN_KEY = SCOLARITE.SCOL_MAQUETTE_UE.FANN_KEY
	AND SCOLARITE.SCOL_FORMATION_ANNEE.FANN_KEY = '2013';
	DBMS_OUTPUT.PUT_LINE('Alimentation de la table UE : OK');

	-- Insertion des données dans IMPORT_PARCOURS
	INSERT INTO SCO_IMPORT.IMPORT_PARCOURS
	(ID_PARCOURS, SPECIALISATION_ID, VOCATION_ID, CODE, LIBELLE_COURT, LIBELLE)
	SELECT IMPORT_PARCOURS_SEQ.nextval, SCO_IMPORT.IMPORT_SPECIALISATION.ID_SPECIALISATION, SCO_IMPORT.IMPORT_VOCATION.ID_VOCATION, MPAR_CODE, MPAR_ABREVIATION, MPAR_LIBELLE
	FROM SCOLARITE.SCOL_MAQUETTE_PARCOURS, SCO_IMPORT.IMPORT_SPECIALISATION, SCO_IMPORT.IMPORT_VOCATION
  	WHERE SCOLARITE.SCOL_MAQUETTE_PARCOURS.FSPN_KEY = SCO_IMPORT.IMPORT_SPECIALISATION.KEY
  	AND SCOLARITE.SCOL_MAQUETTE_PARCOURS.FVOC_CODE = SCO_IMPORT.IMPORT_VOCATION.CODE;
	DBMS_OUTPUT.PUT_LINE('Alimentation de la table Pacours : OK');
  	
	-- Insertion des données dans IMPORT_DIPLOME
	INSERT INTO SCO_IMPORT.IMPORT_DIPLOME
	(ID_DIPLOME, CODE, SISE_MESR, GRADE_UNIVERSITAIRE_ID, DOMAINE_ID, VOCATION_ID, LIBELLE_COURT, LIBELLE, STATUT_FORMATION_ID, TYPE_ORGANISATION_ID, MENTION, SPECIALITE, ANNEE_DEPART, ANNEE_ARRIVEE, MODELE)
	SELECT IMPORT_DIPLOME_SEQ.nextval, SCOL_FORMATION_DIPLOME.FDIP_CODE, SCOL_FORMATION_DIPLOME_SISE.FDIP_CODE_SISE, SCO_IMPORT.IMPORT_GRADE.ID_GRADE, SCO_IMPORT.IMPORT_DOMAINE.ID_DOMAINE, SCO_IMPORT.IMPORT_VOCATION.ID_VOCATION, FDIP_ABREVIATION, FDIP_LIBELLE, SCO_IMPORT.IMPORT_STATUT_FORMATION.ID_STATUT_FORMATION, SCO_IMPORT.IMPORT_TYPE_ORGANISATION.ID_TYPE_ORGANISATION, FDIP_MENTION, FDIP_SPECIALITE, FDIP_DEPART, FDIP_ARRIVEE, FDIP_MODELE
	FROM SCOLARITE.SCOL_FORMATION_DIPLOME, SCOLARITE.SCOL_FORMATION_DIPLOME_SISE, SCO_IMPORT.IMPORT_GRADE, SCO_IMPORT.IMPORT_DOMAINE, SCO_IMPORT.IMPORT_VOCATION, SCO_IMPORT.IMPORT_STATUT_FORMATION, SCO_IMPORT.IMPORT_TYPE_ORGANISATION
  	WHERE SCOLARITE.SCOL_FORMATION_DIPLOME_SISE.FDIP_CODE = SCOLARITE.SCOL_FORMATION_DIPLOME.FDIP_CODE
  	AND SCOLARITE.SCOL_FORMATION_DIPLOME.FGRA_CODE = SCO_IMPORT.IMPORT_GRADE.CODE
  	AND SCOLARITE.SCOL_FORMATION_DIPLOME.FDOM_CODE = SCO_IMPORT.IMPORT_DOMAINE.CODE
  	AND SCOLARITE.SCOL_FORMATION_DIPLOME.FVOC_CODE = SCO_IMPORT.IMPORT_VOCATION.CODE 
  	AND SCOLARITE.SCOL_FORMATION_DIPLOME.FDIP_TYPE = SCO_IMPORT.IMPORT_STATUT_FORMATION.CODE  
  	AND SCOLARITE.SCOL_FORMATION_DIPLOME.FDIP_SEMESTRIALISATION = SCO_IMPORT.IMPORT_TYPE_ORGANISATION.KEY;
	DBMS_OUTPUT.PUT_LINE('Alimentation de la table Diplomes : OK');

	-- Conclusion
	DBMS_OUTPUT.PUT_LINE('Importation des données terminée.');

END;